; //===================================================================================================
; // Mario Dash 
; // Version 1.2 by Eikon (eikon@carolina.rr.com)            
; // written for the blitzcoder.com one button competition 
; // Last Modified 10.14.04
; // Entire project completed in 19 days
; // 
; // ~ Credits ~
; // Chevron & Mark Sibly for their FTP functions
; // XM Music made by Memblers
; //
; // The contest forbids the use of userlibs, thats why the program has no
; // task icon. Window sizing and other issues can be addressed with API but
; // we'll have to suffer and follow the rules ;)
; // 
; // * Update 04.04.04 *
; // Specis specified that the editor must be removed and made a seperate .exe
; // MEdit.bb was created
; //
; // * Update 08.26.04 *
; // Ice Climber graphics mode added thanks to the support of Link Karamelltjyven
; // (link7karamelltjyven@hotmail.com)
; // 
; // * Update 10.14.04 *
; // Castlevania graphics mode added by Eikon
; // New map to go with the new graphics: Castlevania1.mdm
; // New Castlevania music added: Vania1.mid, Vania2.mid
; // 
; // 10.15.04
; // Blitz+ version 1.39 contains a fatal bug that breaks the collision.
; // MDash.exe and MEdit.exe will continue to be built with v1.37
; // 
; //===================================================================================================
Include "ftp.bb"

; // [Menu Constants]
Const cnt_EXIT   = 1
Const cnt_SIZE1  = 2
Const cnt_ABOUT  = 3
Const cnt_FULL   = 4
Const cnt_RESET  = 5
Const cnt_HOME   = 6
Const cnt_HIGH   = 7
Const cnt_SIZE2  = 8
Const cnt_OPEN   = 9
Const cnt_MGFX   = 10
Const cnt_IGFX   = 11
Const cnt_XGFX   = 12

; // [GUI]
Global Parent, Canvas, win_Home, btn_bHome, btn_bBack, btn_bFor, gad_Url, gad_Browse, win_Score
Global btn_Upload, mnu_Mario, mnu_Ice, mnu_Excite
Global img_Mode% = 1, music_File$
LoadGUI(1)

; // [Images]
Global img_b2, img_Mario, img_tiles, img_b3, img_digits, img_logo, img_coin, img_qbox
Global img_coin2, img_Goomba, img_Beatle, img_Koopa, img_Spikey, img_face, img_header

LoadImages 1 ; Load Mario images

Global img_Col = CreateImage(272, 244, 1) ; Collision Layer

; // [Sounds]
Global sfx_Jump = LoadSound("sfx/jump.wav")
Global sfx_Coin = LoadSound("sfx/coin.wav")
Global sfx_Bust = LoadSound("sfx/bust.wav")
Global sfx_Puck = LoadSound("sfx/puck.wav")
Global sfx_Stomp = LoadSound("sfx/stomp.wav")
Global sfx_Pipe = LoadSound("sfx/pipe.wav")
Global sfx_Beep = LoadSound("sfx/beep.wav")
Global sfx_Death = LoadSound("sfx/death.mp3")
Global sfx_Bump = LoadSound("sfx/bump.wav")
Global sfx_Over = LoadSound("sfx/over.mp3")
Global sfx_Win = LoadSound("sfx/win.mp3")

Type Obj
	Field X, Y, F, A, T, F2, FM
End Type

Type Part
	Field A, R, X#, Y, T, ID, R1, R2#, R3, R4
End Type

; // [Declarations]
Global scrX# = 0, oldX# = 0, m_X# = 122, m_Y# = 160, m_Score = 0, m_F = 0, m_World = 1, Map_X = 1
Global m_T = MilliSecs(), m_Time = 0, m_TTime = MilliSecs(), p_F = 0, Channel, m_Speed# = 1
Global CDown_Time = MilliSecs(), CDown_C = 3, obj_F1 = 0, obj_Time = MilliSecs(), m_Lives = 6
Global m_Jump = False, m_Grav# = 3, m_JumpD = 0, m_Fall = False, Mario_Col = False, f_Count = 0
Global b_Clouds = True, req_R = 0, req_G = 0, req_B = 0, b_Death = False, rain_Wind# = 0
Global Death_Time#, old_Map$

Local fps_Count = 0, fps_Current = 0, fps_Time# = MilliSecs() + 1 ; FPS Counter
Local win_Mode = 1

Global b_Debug = False, b_Title = True, b_Fade = False

; // [Logo Fade Routine]
Global Logo_W, Logo_H
Logo_W = ImageWidth(img_logo) / 8: Logo_H = ImageHeight(img_logo) / 8
Dim LogoArray(Logo_W, Logo_H)
For i2 = 0 To Logo_H: For i1 = 0 To Logo_W: LogoArray(i1, i2) = 0: Next: Next

; // [Pre configuration]
Dim Map$(5000, 13) ; Map Array
.lblReset
For i2 = 0 To 13: For i1 = 0 To 5000: Map$(i1, i2) = "x": Next: Next
Channel = PlayMusic("music/title.it", 1): ChannelVolume Channel, .9 ; Load Title Music

TFormFilter 0
SeedRnd MilliSecs()		
AutoSuspend 1
GameTime = CreateTimer(60)
; //===================================================================================================
; // [Main]
; //===================================================================================================
Repeat

Select WaitEvent()                  ; Begin Event Structure
	Case $803
	If EventSource() = Parent Then  ; Exit Program 
		End 
	ElseIf EventSource() = win_Home ; Exit Browser
		FreeGadget win_Home
	ElseIf EventSource() = win_Score ; Exit Score Browser and close FTP connection
		FreeGadget win_Score
	EndIf
	
	Case $101
	If EventData() = 15 Then 
		;DebugLog TextFieldText(gad_Url)
		HtmlViewGo gad_Browse, TextFieldText(gad_Url) ; URL Enter Hotkey
	EndIf
	
	Case $401  ; Gadget Events
	Select EventSource()
		Case btn_bBack: HtmlViewBack gad_Browse                        ; Back
		Case btn_bFor: HtmlViewForward gad_Browse                      ; Forward
		Case btn_bHome: HtmlViewGo gad_Browse, "http://s93151849.onlinehome.us/eik/md/index.htm" ; Home
		Case btn_Upload
		If FTP_Connect("eikon.myftp.org", "user", "blitz", "user") Then
			SetStatusText win_Score, " Connected to eikon.myftp.org [" + CurrentTime() + "]"
			FTP_ChangeDir "/Scores/"
			tmpR$ = "hs" + Str(Rand(1, 2147483647)) + ".mds"
			CopyFile "hs.mds", tmpR$ ; Copy with random name
			FTP_Put tmpR$, 0, 0, 0
			DeleteFile tmpR$ ; Remove copy
			SetStatusText win_Score, " File uploaded successfully [" + CurrentTime() + "]"
			;FTP_Quit()
			DisableGadget btn_Upload
		EndIf
		
	End Select
	
	Case $1001 ; Menu Events
	Select EventData()
		Case cnt_RESET: Reset(): Goto lblReset
		Case cnt_OPEN: old_Map$ = "": OpenMap("custom")
		
		Case cnt_EXIT: End ; End
	
		; Default
		Case cnt_SIZE1: SetGadgetShape Parent, ClientWidth(Desktop())/2-135, ClientHeight(Desktop())/2-138, 270, 276
		; Double
		Case cnt_SIZE2: SetGadgetShape Parent, ClientWidth(Desktop())/2-263, ClientHeight(Desktop())/2-250, 526, 500
	
		Case cnt_FULL ; Fullscreen
		FreeGadget Parent
		Graphics 320, 240, 16, 1
		SetBuffer BackBuffer(): win_Mode = 0
		
		Case cnt_MGFX
		UncheckMenu mnu_Excite: UncheckMenu mnu_Ice: CheckMenu mnu_Mario
		UpdateWindowMenu Parent: img_Mode = 1
		LoadImages 1

		Case cnt_IGFX
		UncheckMenu mnu_Excite: UncheckMenu mnu_Mario: CheckMenu mnu_Ice
		UpdateWindowMenu Parent: img_Mode = 2
		LoadImages 2

		Case cnt_XGFX
		CheckMenu mnu_Excite: UncheckMenu mnu_Mario: UncheckMenu mnu_Ice
		UpdateWindowMenu Parent: img_Mode = 3
		LoadImages 3
		
		Case cnt_HOME: LoadGUI(2) ; Home
	 	Case cnt_HIGH: LoadGUI(3) ; High Scores
	
		; About
		Case cnt_ABOUT: Notify "Mario Dash version 1.2" + Chr$(10) + "by Eikon" + Chr$(10) + Chr$(10) + "Special thanks to Link K."
	
	End Select
	
	Case $4001
	Cls
	fps_Count = fps_Count + 1
	If MilliSecs() >= fps_Time Then fps_Current = fps_Count: fps_Count = 0: fps_Time = fps_Time + 1000

	If win_Mode = 0 Then Origin 32, 8: tmp_X = 32: tmp_Y = 8 Else Origin 0, 0: tmp_X = 0: tmp_Y = 0
	Color req_R, req_G, req_B: Rect 0, 0, 256, 224, 1
	If b_Title = True Then Viewport 0+tmp_X, 192+tmp_Y, 256, 32: TileBlock img_b3, scrX, 0
	If b_Clouds = True Then Viewport 0+tmp_X, 17+tmp_Y, 256, 51: TileImage img_b2, scrX/2, 17
	Viewport 0+tmp_X, 0+tmp_Y, 256, 224
	
	If b_Title = True Then ; Title Screen
		RenderTitle() 
	Else                    ; Game play
		If CDown_C > -1 Then ; Count Down
			If MilliSecs() >= CDown_Time + 1000 Then 
				CDown_C = CDown_C - 1: CDown_Time = MilliSecs()
				If CDown_C <= -1 Then ResumeChannel Channel: FlushKeys(): Else PlaySound sfx_Beep
			EndIf
			For o.Obj = Each Obj: DrawImage img_tiles, o\X + (scrX - oldX), o\Y, o\F: Next
			DrawImage img_Mario, m_X, m_Y, m_F: oldX = scrX: UpdateMap(1)			
		Else
			Mario_Col = False
			RenderObj()  ; Render Objects (tiles, enemies, coins, etc)
			RenderPart() ; Render Particle Effects
			;DrawImage img_Col, 0 + (scrX - oldX), 0 ;       Uncomment to see collision layer
			
			If b_Death = True Then ; Death Sequence
				m_F = 6: m_Y = m_Y - m_Grav#: FlushKeys()
				m_Grav = m_Grav - .04
				DrawImage img_Mario, m_X, m_Y, m_F
				If MilliSecs() >= Death_Time + 2500 Then 
					If m_Lives > 0 Then 
						OpenMap("") 
					Else 
						Channel = PlaySound(sfx_Over)
						.lblRepeat
						Cls
						DrawImage img_header, 24, 8
						d_Text 24, 16, Str(m_Score), 1  ; Score
						d_Text 208, 16, Str(m_Time), 2  ; Time
						d_Text 160, 16, Str(m_World), 3 ; World
						Color 255, 255, 255: Text 93, 106, "GAME OVER"
						WaitTimer GameTime
						If win_Mode = 1 Then VWait 1: FlipCanvas Canvas, 1 Else Flip 1
						If ChannelPlaying(Channel) = False Then Reset: Goto lblReset Else Goto lblRepeat
					EndIf
				EndIf
				Goto StepOver
			EndIf

			If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X + 16, m_Y + 16, 2, 16) Then ; Forward Collision
				m_X = (m_X - m_Speed) -.01: Mario_Col = True
			EndIf
			
			If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X-2, m_Y + 32, 18, 3) Then ; Landing Collision
				If m_Jump = True And m_JumpD = 1 Then 
					m_Jump = False: m_F = 1
				Else
					If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 28, 16, 1) Then
						m_Y = m_Y - 4
					ElseIf ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 29, 16, 1) Then
						m_Y = m_Y - 3
					ElseIf ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 30, 16, 1) Then
						m_Y = m_Y - 2
					ElseIf ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 31, 16, 1) Then
						m_Y = m_Y - 1
					ElseIf Not ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 32, 16, 1) Then
						m_Y = m_Y + 1
					ElseIf Not ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, m_X, m_Y + 33, 16, 1) Then
						m_Y = m_Y + 2
					EndIf
				EndIf
				m_Fall = False
			Else
				If m_Jump = False Then m_Fall = True
			EndIf
	
			If Mario_Col = False And m_X < 122 Then 
				m_X = m_X + m_Speed ; Collision
			Else                    ; Scroll
				If Mario_Col = True And m_Jump = True And m_JumpD = 0 Then
				Else
					scrX = scrX - m_Speed
					If scrX <= oldX - 16 Then oldX = scrX: Map_X = Map_X + 1: UpdateMap(2)
				EndIf
			EndIf
			
			For i = 1 To m_Lives
				DrawImage img_face, ((i-1) * 12)+5, 210
			Next			
			
			If m_Fall = True Then m_Y = m_Y + 3
			
			DrawImage img_Mario, m_X, m_Y, m_F
			If m_Speed = .8 ; Walk
				If MilliSecs() >= m_T + 100 And m_Fall = False Then m_F = m_F + 1: m_T = MilliSecs()
			Else ; Run
				If MilliSecs() >= m_T + 50 And m_Fall = False Then m_F = m_F + 1: m_T = MilliSecs()
			EndIf
							
			If m_F >= 4 And m_Fall = False Then m_F = 1
	
			If MilliSecs() >= m_TTime + 1000 Then m_Time = m_Time + 1: m_TTime = MilliSecs()
	
			If m_X < - 16 Or m_Y + 16 > 224 And b_Death = False Then ; Die
				b_Death = True: m_Lives = m_Lives - 1: m_Grav# = 3
				PauseChannel Channel: PlaySound sfx_Death: Death_Time = MilliSecs()
			EndIf
			
			If m_Jump = True Then ; Jump
				m_Y = m_Y - m_Grav#: m_F = 5
				If m_JumpD = 0 Then 
					If KeyDown(57) Then m_Grav# = m_Grav# - .07 Else m_Grav# = m_Grav# - .2
				EndIf
				If m_JumpD = 1 Then m_Grav# = m_Grav# - .2
				If m_Grav# <= 0 Then m_JumpD = 1
				If m_Grav# <= -3 Then m_Grav# = -3; m_Jump = False: m_F = 1
				;If m_Y >= 160 Then m_Y = 160: m_Jump = False: m_F = 1
			EndIf
					
			If KeyHit(57) And m_Jump = False And m_Fall = False Then 
				PlaySound sfx_Jump: m_Jump = True
				m_Grav# = 3: m_JumpD = 0
			EndIf
			m_Speed = .8
			If KeyDown(57) Or m_Jump = True Then m_Speed = 1.3
			
		EndIf
	EndIf
	
	.StepOver
	If b_Debug = True Then
		VMem$ = Str((TotalVidMem()-AvailVidMem())/1024)
		Color 255, 255, 255: Text 1, 208, "Used VMem: " + VMem$ + "kbs"
		Text 1, 192, "FPS: " + fps_Current
	EndIf
	
	DrawImage img_header, 24, 8
	d_Text 24, 16, Str(m_Score), 1  ; Score
	d_Text 208, 16, Str(m_Time), 2  ; Time
	d_Text 160, 16, Str(m_World), 3 ; World
	If CDown_C > -1 And b_Title = False Then Color 255, 255, 255: Text 122, 100, CDown_C + 1

    If KeyHit(1) And win_Mode = 0 Then ; Back to windowed
		EndGraphics
		LoadGUI(1): win_Mode = 1
	EndIf
	
	If win_Mode = 1 Then VWait 1: FlipCanvas Canvas, 0 Else Flip 1 ;  Comment this and
	;If win_Mode = 1 FlipCanvas Canvas, 0 Else Flip 0                 uncomment this to disable
	.StepOut                                                       ;  frame limiting
	
End Select
Forever

; //===================================================================================================
; // [Update Map Function]
; //===================================================================================================
Function UpdateMap(Mode) ; Full update or just right side?
If Mode = 1 Then ; Update entire screen
	Old_Buff = GraphicsBuffer()
	SetBuffer ImageBuffer(img_Col)
	Cls
	Delete Each Obj
	tmpX = 0: tmpY = 0
	For i2 = 0 To 13
		For i1 = Map_X To Map_X + 17
			If Map$(i1, i2) <> "x" Then ; Create Obj
				o.Obj = New Obj: o\X = tmpX: o\Y = tmpY: o\F = Int(Map$(i1, i2))
				If Ignored_Tile(o\F) = False Then Color 255, 0, 0: Rect tmpX, tmpY, 16, 16, 1
			EndIf
			tmpX = tmpX + 16
		Next
		tmpX = 0: tmpX2 = 1: tmpY = tmpY + 16
	Next
	SetBuffer Old_Buff
	
ElseIf Mode = 2 Then ; Scrolling Update
	For o.Obj = Each Obj
		If o\X < 0 Then Delete o Else o\X = o\X - 16
	Next ; Remove back row only
	For p.Part = Each Part
		If p\ID >= 5 Or p\ID <= 8 Then p\X = p\X - 16
	Next
	CopyRect 0, 0, 272, 224, -16, 0, ImageBuffer(img_Col), ImageBuffer(img_Col)
	
	Old_Buff = GraphicsBuffer()
	SetBuffer ImageBuffer(img_Col)
	tmpX = 0: tmpY = 0
	For i2 = 0 To 13
		If Map$(Map_X + 17, i2) <> "x" Then ; Create Obj
			tmpT = Int(Map$(Map_X + 17, i2))
			If tmpT = 63 Or tmpT = 59 Or tmpT = 60 Or tmpT = 61 Then	
				p.Part = New Part
				p\X = 256: p\Y = i2 * 16: p\R1 = 0: p\T = MilliSecs(): p\R3 = 0: p\A = 0			
				If tmpT = 63 Then p\ID = 11: p\R1 = 0  
				If tmpT = 59 Then p\ID = 12: p\R1 = 0
				If tmpT = 60 Then p\ID = 13: p\R1 = 6
				If tmpT = 61 Then p\ID = 50
			ElseIf tmpT >= 38 And tmpT <= 43 Then ; Goomba
				p.Part = New Part
				p\X = 256: p\Y = i2 * 16: p\R1 = 0: p\T = MilliSecs(): p\R3 = 0: p\A = 0
				If tmpT = 38 Then p\ID = 5: p\R1 = 0
				If tmpT = 39 Then p\ID = 6: p\R1 = 3
				If tmpT = 40 Then p\ID = 7: p\R1 = 6
				If tmpT = 41 Then p\ID = 8: p\R1 = 0
				If tmpT = 42 Then p\ID = 9: p\R1 = 6
				If tmpT = 43 Then p\ID = 10: p\R1 = 12			
			Else
				o.Obj = New Obj: o\X = 256: o\Y = tmpY: o\F = Int(Map$(Map_X + 17, i2))
				If Ignored_Tile(o\F) = False Then 
					Color 255, 0, 0: Rect 256, tmpY, 16, 16, 1
				Else
					Color 0, 0, 0: Rect 256, tmpY, 16, 16, 1
				EndIf

				If o\F = 37 Or o\F = 36 Then o\F2 = obj_F1: o\FM = 4
			EndIf
		Else
			Color 0, 0, 0: Rect 256, tmpY, 16, 16, 1	
		EndIf
		tmpY = tmpY + 16
	Next
	SetBuffer Old_Buff
EndIf
End Function

; //===================================================================================================
; // [Render Title]
; //===================================================================================================
Function RenderTitle()
	DrawImage img_logo, 40, 50
	scrX = scrX - 1
	
	DrawImage img_Mario, 121, m_Y, m_F
	If MilliSecs() >= m_T + 100 Then m_F = m_F + 1: m_T = MilliSecs()
	If m_F >= 4 Then m_F = 1

	For i = 1 To 2
		p.Part = New Part
		p\ID = 3: p\X = Rand(-30, 286): p\Y = -5: p\R1 = rain_Wind#
	Next
	
	RenderPart()
	
	If MilliSecs() >= m_TTime + 500 Then 
		m_TTime = MilliSecs()
		p_F = p_F + 1: If p_F >= 2 Then p_F = 0
	EndIf
	
	If b_Fade = False Then
		Color 255, 255, 255
		If p_F = 0 Then Text 84, 145, "Press Space"
	Else ; Fade Out
		OldBuffer = GraphicsBuffer()
		For i = 1 To 10
			tmpX = Rand(0, ImageWidth(img_logo)/8): tmpY = Rand(0, ImageHeight(img_logo)/8)
			If LogoArray(tmpX, tmpY) = 0 Then LogoArray(tmpX, tmpY) = 1
		Next
		
		SetBuffer ImageBuffer(img_logo): tmp_Done = 0
			For i2 = 0 To Logo_H
				For i1 = 0 To Logo_W
					If LogoArray(i1, i2) = 1 Then Color 255, 0, 255: Rect i1 * 8, i2 * 8, 8, 8, 1: LogoArray(i1, i2) = 2
					If LogoArray(i1, i2) = 2 Then tmp_Done = tmp_Done + 1
				Next
			Next
		SetBuffer OldBuffer
		If tmp_Done >= 225 Then 
			b_Title = False: StopChannel Channel
			OpenMap "game" ; Begin Game
		EndIf
	EndIf
	
	If KeyHit(57) And b_Fade = False Then b_Fade = True: PlaySound sfx_Pipe ; Exit Title
		
End Function

; //===================================================================================================
; // [Open Map Function]
; //===================================================================================================
Function OpenMap(fname$)

If fname$ = "custom" Or Left$(old_Map$, 1) = "C" Then
	If Left$(old_Map$, 1) = "C" Then 
		;DebugLog Right$(old_Map$, Len(old_Map$) - 1)
		File = ReadFile(Right$(old_Map$, Len(old_Map$) - 1))
	Else
		tmp$ = RequestFile("Open Map", "mdm", False)
		If tmp$ = "" Then Goto stepOver2
		old_Map$ = "C" + tmp$
		File = ReadFile(tmp$)
	EndIf
	StopChannel Channel: b_Title = False
Else
	File = ReadFile("lvl/lev" + Str(m_World) + ".mdm")
	old_Map$ = "level"
EndIf

FlushKeys(): Delete Each Part: Delete Each Obj
For i2 = 0 To 13: For i1 = 0 To 5000: Map(i1, i2) = "x": Next: Next

tmp$ = ReadString(File)
Channel = PlayMusic("music/" + tmp$, 1)
music_Name$ = "music/" + tmp$
If Right(tmp$, 3) <> "mid" Then ChannelVolume Channel, .9 Else ChannelVolume Channel, .6
PauseChannel Channel
tmp = ReadByte(File)
If tmp = 1 Then b_Clouds = True Else b_Clouds = False
req_R = ReadByte(File): req_G = ReadByte(File): req_B = ReadByte(File)

tmpBX = ReadShort(File)

For i2 = 0 To 13
	For i1 = 0 To tmpBX
		tmp = ReadByte(File)
		If tmp = 255 Then Map(i1, i2) = "x" Else Map(i1, i2) = Str(tmp)		
	Next
Next

CloseFile File
scrX = 0: b_Death = False: CDown_C = 3: oldX = scrX
oldX# = 0: m_X# = 122: m_Y# = 160: m_F = 0: Map_X = 1; m_Score = 0
m_T = MilliSecs(): m_Time = 0: m_TTime = MilliSecs(): m_Speed# = 1
obj_F1 = 0: obj_Time = MilliSecs(): m_Jump = False: m_Grav# = 3: m_JumpD = 0: m_Fall = False: Mario_Col = False: f_Count = 0
.StepOver2
End Function

; //===================================================================================================
; // [Load GUI Function]
; //===================================================================================================
Function LoadGUI(mode)
If mode = 1 Then ; Main Window
	AppTitle "Mario Dash"
	Parent = CreateWindow("Mario Dash", ClientWidth(Desktop())/2-135, ClientHeight(Desktop())/2-138, 270, 276, 0, 1 + 2 + 4)
	hWnd = QueryObject(Parent, 1)
	icon = LoadIcon(hWnd, "task1.ico", 0)
	SetClassLong hwnd, -14, icon
	
	SetMinWindowSize Parent, 270, 276
	Panel  = CreatePanel(1, 1, 260, 228, Parent, -1)
	Canvas = CreateCanvas(0, 0, 256, 224, Panel)
	SetBuffer CanvasBuffer(Canvas)
	Font = LoadFont("FixedSys", 10, 0, 0, 0) ; Set Font
	SetFont Font
	
	; // [Menu]
	Menu = WindowMenu(Parent)
	File = CreateMenu("&File", 0, Menu)
	CreateMenu "&Reset", cnt_RESET, File
	CreateMenu "O&pen Map", cnt_OPEN, File
	CreateMenu "", 0, File
	CreateMenu "E&xit", cnt_EXIT, File
	Options = CreateMenu("&Options", 0, Menu)
	CreateMenu "&Default", cnt_SIZE1, Options
	CreateMenu "Dou&ble", cnt_SIZE2, Options
	mnu_Full = CreateMenu("F&ull Screen", cnt_FULL, Options)
	CreateMenu "", 0, Options
	mnu_Gfx = CreateMenu("Graphics", 0, Options)
	mnu_Mario = CreateMenu("Super Mario", cnt_MGFX, mnu_Gfx)
	mnu_Ice = CreateMenu("Ice Climber", cnt_IGFX, mnu_Gfx)
	mnu_Excite = CreateMenu("Castlevania", cnt_XGFX, mnu_Gfx)
	Online = CreateMenu("&Online", 0, Menu)
	CreateMenu "Ho&me", cnt_HOME, Online
	CreateMenu "&High Scores", cnt_HIGH, Online
	Help = CreateMenu("&Help", 0, Menu)
	CreateMenu "&About", cnt_ABOUT, Help

	If img_Mode = 1 Then CheckMenu mnu_Mario
	If img_Mode = 2 Then CheckMenu mnu_Ice
	If img_Mode = 3 Then CheckMenu mnu_Excite

	UpdateWindowMenu Parent

	; // [Gadget Sizing]
	SetGadgetLayout Panel, 2, 1, 2, 1
	SetGadgetLayout Canvas, 2, 1, 2, 1
	
ElseIf mode = 2 Or mode = 3 Then
	If mode = 2 Then ; Home
		win_Home = CreateWindow("Mario Dash [Home]", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2 + 8)
		gad_Browse = CreateHtmlView(1, 27, 643, 455, win_Home)           ; Browser
		btn_bBack = CreateButton("< Back", 3, 3, 60, 21, win_Home, 1)    ; Back Button
		btn_bFor = CreateButton("Forward >", 64, 3, 60, 21, win_Home, 1) ; Forward Button
		btn_bHome = CreateButton("Home", 125, 3, 60, 21, win_Home, 1)    ; Home Button
		lbl_Url = CreateLabel("URL:", 188, 11, 24, 14, win_Home, 0)      ; URL Label
		gad_Url = CreateTextField(215, 6, 428, 18, win_Home, 0)          ; Address Field
		HotKeyEvent 28, 0, $101, 15, 0, 0, 0, 0 ; Enter Hotkey
	
		SetGadgetLayout gad_Browse, 1, 2, 1, 2
		SetGadgetLayout btn_bBack, 1, 2, 1, 0
		SetGadgetLayout btn_bFor, 2, 2, 1, 0
		SetGadgetLayout btn_bHome, 2, 2, 1, 0 
		SetGadgetLayout lbl_Url, 2, 2, 1, 0
		SetGadgetLayout gad_Url, 2, 2, 1, 0
		
		SetGadgetText gad_Url, "http://s93151849.onlinehome.us/eik/md/index.htm"
		HtmlViewGo gad_Browse, "http://s93151849.onlinehome.us/eik/md/index.htm"
		SetStatusText win_Home, " Welcome to the EikSoft homepage"
		SetMinWindowSize win_Home, 652, 530
	ElseIf mode = 3 Then ; High Score
		win_Score = CreateWindow("Mario Dash [Online Score Database]", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2 + 8)
		SetMinWindowSize win_Score, 652, 530
		gad_Browse = CreateHtmlView(1, 1, 643, 444, win_Score)           ; Browser
		SetGadgetLayout gad_Browse, 1, 2, 1, 2
		HtmlViewGo gad_Browse, "http://s93151849.onlinehome.us/eik/md/scores.htm"
		SetStatusText win_Score, " Welcome to the High Score Database"
		Font = LoadFont("Verdana", 16, 0, 0, 0)
		btn_Upload = CreateButton("Upload Your High Scores", 226, 448, 200, 32, win_Score, 1)
		SetGadgetFont btn_Upload, Font
		SetGadgetLayout btn_Upload, 2, 2, 2, 2
		
	EndIf
	ActivateGadget gad_Browse
	
EndIf
End Function

; //===================================================================================================
; // [Bitmap Font Text Function]
; //===================================================================================================
Function d_Text(X, Y, digits$, mode)
If mode = 1 ; Score
	If Len(digits$) = 1 Then digits$ = "00000" + digits$
	If Len(digits$) = 2 Then digits$ = "0000" + digits$
	If Len(digits$) = 3 Then digits$ = "000" + digits$
	If Len(digits$) = 4 Then digits$ = "00" + digits$
	If Len(digits$) = 5 Then digits$ = "0" + digits$
ElseIf mode = 2 Then ; Time
	If Len(digits$) = 1 Then digits$ = "00" + digits$
	If Len(digits$) = 2 Then digits$ = "0" + digits$
EndIf

tmp_X = X
For i = 1 To Len(digits$)
	num = (Asc(Mid(digits$, i, 1)))-48 
	DrawImage img_digits, tmp_X, Y, num
	tmp_X = tmp_X + 8
Next

End Function

; //===================================================================================================
; // [Render Object Function]
; //===================================================================================================
Function RenderObj()
For o.Obj = Each Obj
	Del = 0
	
	If Ignored_Tile(o\F) = True Or b_Death = True Then Goto StepOut2

	If ImageRectCollide(img_tiles, o\X + (scrX - oldX), o\Y, o\F, m_X, m_Y + 15, 16, 1) And m_Jump = True Then ; Head Collision
		m_JumpD = 1: m_Grav# = 1: m_F = 1
		m_Y = o\Y
		tmpF = o\F
		If o\F = 18 Or o\F = 2 Or o\F = 3 Then 
			For i = 1 To 25 ; Create Brick Particles
				p.Part = New Part
				p\A = Rand(0, 359): p\R = 1: p\X = (o\X + 8): p\Y = o\Y + 8: p\T = MilliSecs()
				p\R1 = Rand(1, 2): p\R2 = Rand(20, 45): p\R3 = Rand(1, 2) ; Random
				p\R4 = Rand(1, 2)
				If tmpF = 3 Then p\ID = 2 Else p\ID = 1
			Next
			
			Old_Buffer = GraphicsBuffer() ; Erase Brick from collision image
			SetBuffer ImageBuffer(img_Col)
			Color 0, 0, 0: Rect o\X, o\Y, 16, 16, 1
			SetBuffer Old_Buffer
			
			Del = 1: PlaySound sfx_Bust ; Bust Bricks
		EndIf
		If o\F = 36 Then ; Question Box
			PlaySound sfx_Bump
			o\F = 30: m_Score = m_Score + 200
			p.Part = New part
			p\X = (o\X + 5): p\Y = (o\Y-16) + 8: p\R1 = 0: p\R2 = 3: p\ID = 4: p\R3 = MilliSecs()
		EndIf
		m_Fall = True
	EndIf

	.StepOut2
	If o\F = 36 Then     ; Question Box
		DrawImage img_qbox, o\X + (scrX - oldX), o\Y, o\F2
		o\F2 = obj_F1
	ElseIf o\F = 37 Then ; Coin
		DrawImage img_coin, o\X + (scrX - oldX) + 3, o\Y, o\F2
		o\F2 = obj_F1
		If ImagesCollide(img_coin, o\X + (scrX - oldX), o\Y, o\F2, img_Mario, m_X, m_Y, m_F) Then 
			If b_Death = False Then Delete o: PlaySound sfx_Coin: m_Score = m_Score + 10
		EndIf
	ElseIf o\F = 35 Or o\F = 54 Then ; Railing
		DrawImage img_tiles, o\X + (scrX - oldX), o\Y - 8, o\F
	Else
		DrawImage img_tiles, o\X + (scrX - oldX), o\Y, o\F
	EndIf

	If del = 1 Then Delete o
Next

If MilliSecs() >= obj_Time + 150 Then obj_F1 = obj_F1 + 1: obj_Time = MilliSecs()
If obj_F1 >= 4 Then obj_F1 = 0
End Function

; //===================================================================================================
; // [Reset Function]
; //===================================================================================================
Function Reset()
StopChannel Channel
scrX# = 0: oldX# = 0: m_X# = 122: m_Y# = 160: m_Score = 0: m_F = 0: m_World = 1: Map_X = 1
m_T = MilliSecs(): m_Time = 0: m_TTime = MilliSecs(): p_F = 0: m_Speed# = 1
CDown_Time = MilliSecs(): CDown_C = 3: obj_F1 = 0: obj_Time = MilliSecs(): m_Lives = 6
m_Jump = False: m_Grav# = 3: m_JumpD = 0: m_Fall = False: Mario_Col = False: f_Count = 0
b_Clouds = True: req_R = 0: req_G = 0: req_B = 0: b_Death = False: rain_Wind# = 0

FlushKeys(): Delete Each Part: Delete Each Obj

fps_Count = 0: fps_Current = 0: fps_Time# = MilliSecs() + 1 ; FPS Counter
win_Mode = 1

b_Debug = False: b_Title = True: b_Fade = False
FreeImage img_logo
If img_Mode = 1 Then
	img_logo = LoadImage("gfx/logo.png"): MaskImage img_logo, 255, 0, 255
ElseIf img_Mode = 2 Then
	img_logo = LoadImage("gfx2/logo.png"): MaskImage img_logo, 255, 0, 255
ElseIf img_Mode = 3 Then
	img_logo = LoadImage("gfx3/logo.png"): MaskImage img_logo, 255, 0, 255
EndIf

; // [Logo Fade Routine]
Logo_W = ImageWidth(img_logo) / 8: Logo_H = ImageHeight(img_logo) / 8
For i2 = 0 To Logo_H: For i1 = 0 To Logo_W: LogoArray(i1, i2) = 0: Next: Next
old_Map$ = ""

End Function

; //===================================================================================================
; // [Render Particle Function]
; //===================================================================================================
Function RenderPart()
For p.Part = Each Part
	Del = 0
	If p\ID = 1 Then     ; Brown
		If p\R4 = 1 Then Color 0, 0, 0 Else Color 200, 76, 12
	Else                 ; Blue
		If p\R4 = 1 Then Color 0, 0, 0 Else Color 0, 128, 136
	EndIf
	
	If p\ID = 1 Or p\ID = 2 Then
		Rect p\R * Cos(p\A) + (p\X + (scrX - oldX)), p\R * Sin(p\A) + p\Y, p\R3, p\R3
		p\R = p\R + p\R1
		If p\R >= p\R2 Then Del = 1
	ElseIf p\ID = 3 Then ; Rain
		Color 46, 14, 173: Rect p\X, p\Y, 1, 1, 1
		tmpXO = 0
		If rain_Wind < -.5 Then tmpXO = -1 
		If rain_Wind# > .5 Then tmpXO = 1
		Color 57, 17, 217: Rect p\X + tmpX0, p\Y + 1, 1, 1
		Color 67, 24, 237: Rect p\X + tmpX0, p\Y + 2, 1, 1
		tmpXO = 0
		If rain_Wind < -.5 Then tmpXO = -2 
		If rain_Wind# > .5 Then tmpXO = 2
		If rain_Wind < -.2 Then tmpXO = -1
		If rain_Wind# > .2 Then tmpXO = 1
		Color 89, 52, 239: Rect p\X + tmpX0, p\Y + 3, 1, 1
		Color 116, 84, 241: Rect p\X + tmpX0, p\Y + 4, 1, 1
		
		p\R1 = rain_Wind
		p\Y = p\Y + 3
		rain_Wind# = rain_Wind# + Rnd(-.01, .01)
		p\X = p\X + rain_Wind#
		If rain_Wind# < -1 Then rain_Wind# = -1
		If rain_Wind# > 1 Then rain_Wind# = 1
		If p\Y + 5 >= 194 Or ImageRectCollide(img_logo, 40, 50, 0, p\X + p\R1, p\Y + 5, 1, 1) Then Delete p
	ElseIf p\ID = 4 Then ; Pop up Coin
		DrawImage img_coin2, p\X + (scrX - oldX), p\Y, p\R1
		If MilliSecs() >= p\R3 + 100 Then p\R1 = p\R1 + 1: p\R3 = MilliSecs()
		If p\R1 >= 4 Then p\R1 = 0
		p\Y = p\Y - p\R2#
		p\R2# = p\R2# - .08
		If p\R2# <= -1 Then Delete p: PlaySound sfx_Coin
	ElseIf p\ID >= 5 And p\ID <= 13 Then ; Goomba
		; Object ID Chart
		; 1  - Red Brick
		; 2  - Blue Brick
		; 3  - Rain
		; 4  - Pop-Up Coin
		; 5  - Red Goomba
		; 6  - Blue Goomba
		; 7  - Gray Gooma
		; 8  - Black Beatle
		; 9  - Blue Beatle
		; 10 - Gray Beatle
		; 11 - Spiney
		; 12 - Green Koopa
		; 13 - Red Koopa
		; 50 - Flag Pole
		If p\R3 = 1 Then ; Death Frame
			If p\ID = 5 Then p\R1 = 2
			If p\ID = 6 Then p\R1 = 5
			If p\ID = 7 Then p\R1 = 8
			If p\ID = 8 Then p\R1 = 2
			If p\ID = 9 Then p\R1 = 8
			If p\ID = 10 Then p\R1 = 14
			If p\ID = 12 Then p\R1 = 2
			If p\ID = 13 Then p\R1 = 8	
		EndIf
		
		If p\A = 1 Then
			If p\ID > 11 Then ; Koopa
				tmp_Face = 3
			ElseIf p\ID >= 8 And p\ID <= 10 Then 
				tmp_Face = 3
			ElseIf p\ID = 11 Then ; Spikey
				tmp_Face = 2
			EndIf
		Else 
			tmp_Face = 0
		EndIf
		
		If p\ID <= 7 Then ; Goomba
			DrawImage img_Goomba, p\X + (scrX - oldX), p\Y, p\R1
		ElseIf p\ID >= 8 And p\ID <= 10 Then ; Beatle
			DrawImage img_Beatle, p\X + (scrX - oldX), p\Y, p\R1 + tmp_Face
		ElseIf p\ID = 11 Then ; Spikey
			DrawImage img_Spikey, p\X + (scrX - oldX), p\Y, p\R1 + tmp_Face
		ElseIf p\ID > 11 Then ; Koopa	
			DrawImage img_Koopa, p\X + (scrX - oldX), p\Y-8, p\R1 + tmp_Face
		EndIf
		
		If p\R3 = 0 Then
			If p\A = 0 Then p\X = p\X - .5 Else p\X = p\X + .5
		EndIf
		
		If MilliSecs() >= p\T + 200 Then 
			If p\R3 = 1 Then 
				Del = 1
				If p\ID <= 7 Then 
					m_Score = m_Score + 100 
				ElseIf p\ID >= 8 Or p\ID <= 10 Then
					m_Score = m_Score + 200
				EndIf
			EndIf
			p\R1 = p\R1 + 1: p\T = MilliSecs()
		EndIf		

		If p\ID = 5 Or p\ID = 8 Or p\ID = 12 Then     ; Red Goombas, Black Beatles, and Green Koopas
			If p\R1 >= 2 Then p\R1 = 0
		ElseIf p\ID = 13 Or p\ID = 9 Then ; Blue Beatles, and Red Koopas
			If p\R1 >= 8 Then p\R1 = 6
		ElseIf p\ID = 6                    ; Blue Goomba
			If p\R1 >= 5 Then p\R1 = 3
		ElseIf p\ID = 7 Then               ; Gray Goomba
			If p\R1 >= 8 Then p\R1 = 6
		ElseIf p\ID = 11 Then
			If p\R1 >= 2 Then p\R1 = 0
		ElseIf p\ID = 10 Then 
			If p\R1 >= 14 Then p\R1 = 12
		EndIf
	
		If p\ID <= 7 Then ; Goomba
			If ImageRectCollide(img_Goomba, p\X + (scrX - oldX), p\Y, p\R1, m_X + 16, m_Y + 16, 1, 12) Then 
				If b_Death = False And p\R3 = 0 Then
					b_Death = True: m_Lives = m_Lives - 1: m_Grav# = 3
					PauseChannel Channel: PlaySound sfx_Death: Death_Time = MilliSecs()
				EndIf
			EndIf
		
			If ImageRectCollide(img_Goomba, p\X + (scrX - oldX), p\Y, p\R1, m_X, m_Y + 32, 16, 4) Then 
				If b_Death = False Then
					If p\R3 = 0 Then p\R3 = 1: PlaySound sfx_Stomp
					m_Jump = True: m_Grav# = 2: m_JumpD = 0
				EndIf
			EndIf
		ElseIf p\ID >= 8 And p\ID <= 10 Then ; Beatle
			If ImageRectCollide(img_Beatle, p\X + (scrX - oldX), p\Y, p\R1, m_X + 16, m_Y + 16, 1, 12) Then 
				If b_Death = False And p\R3 = 0 Then
					b_Death = True: m_Lives = m_Lives - 1: m_Grav# = 3
					PauseChannel Channel: PlaySound sfx_Death: Death_Time = MilliSecs()
				EndIf
			EndIf
			If ImageRectCollide(img_Beatle, p\X + (scrX - oldX), p\Y, p\R1, m_X, m_Y + 32, 16, 4) Then 
				If b_Death = False Then
					If p\R3 = 0 Then p\R3 = 1: PlaySound sfx_Bump
					m_Jump = True: m_Grav# = 2: m_JumpD = 0
				EndIf
			EndIf
		ElseIf p\ID = 11 Then ; Spikey
			tmp = False
			If ImageRectCollide(img_Spikey, p\X + (scrX - oldX), p\Y, p\R1, m_X + 16, m_Y + 16, 1, 12) Then tmp = True
			If ImageRectCollide(img_Spikey, p\X + (scrX - oldX), p\Y, p\R1, m_X, m_Y + 32, 16, 1) Then tmp = True
			If tmp = True
				If b_Death = False And p\R3 = 0
					b_Death = True: m_Lives = m_Lives - 1: m_Grav# = 3
					PauseChannel Channel: PlaySound sfx_Death: Death_Time = MilliSecs()
				EndIf
			EndIf
		ElseIf p\ID > 11 Then ; Koopa
			If ImageRectCollide(img_Koopa, p\X + (scrX - oldX), p\Y, p\R1, m_X + 16, m_Y + 16, 1, 12) Then 
				If b_Death = False And p\R3 = 0 Then
					b_Death = True: m_Lives = m_Lives - 1: m_Grav# = 3
					PauseChannel Channel: PlaySound sfx_Death: Death_Time = MilliSecs()
				EndIf
			EndIf
		
			If ImageRectCollide(img_Koopa, p\X + (scrX - oldX), p\Y, p\R1, m_X, m_Y + 32, 16, 3) Then 
				If b_Death = False Then
					If p\R3 = 0 Then p\R3 = 1: PlaySound sfx_Bump
					m_Jump = True: m_Grav# = 2: m_JumpD = 0
				EndIf
			EndIf
		EndIf
		
		; Left
		If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, p\X + (scrX - oldX), p\Y, 1, 16) Then 
			If p\A = 0 Then p\A = 1
		EndIf ; Right
		If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, (p\X + 15) + (scrX - oldX), p\Y, 1, 16) Then  
			If p\A = 1 Then p\A = 0
		EndIf
		
		If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, p\X-4, p\Y + 16, 14, 2) Then
			If p\R4 = True Then
				; Land and align
				If ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, p\X, p\Y + 13, 16, 1) Then
					p\Y = p\Y - 3
				ElseIf ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, p\X, p\Y + 14, 16, 1) Then
					p\Y = p\Y - 2
				ElseIf ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0, p\X, p\Y + 15, 16, 1) Then
					p\Y = p\Y - 1
				ElseIf Not ImageRectCollide(img_Col, 0 + (scrX - oldX), 0, 0,  p\X, p\Y + 17, 16, 1) Then
					p\Y = p\Y + 1
				EndIf
				p\R4 = False
			EndIf
		Else         ; Fall
			p\Y = p\Y + 2
			p\R4 = True
		EndIf
		
	ElseIf p\ID = 50 Then
		DrawImage img_tiles, p\X + (scrX - oldX), p\Y, 61
		If ImageRectCollide(img_Mario, m_X, m_Y, m_F, (p\X + (scrX - oldX))+ 8, p\Y, 16, 16) Then 
			m_World = m_World + 1
			StopChannel Channel
			Channel = PlaySound(sfx_Win)
			Repeat: Until ChannelPlaying(Channel) = False
			If m_World = 6 Then m_World = 1
			OpenMap("")
		EndIf
	EndIf
	If Del = 1 Then Delete p
Next
End Function

; //===================================================================================================
; // [Ignored Tile Function]
; //===================================================================================================
Function Ignored_Tile(tnum)
If tnum >= 16 And tnum <= 29 And tnum <> 24 And tnum <> 18 Then Return True
If tnum = 37 Then Return True
If tnum >= 44 And tnum <= 53 And tnum <> 52 Then Return True
If tnum = 64 Then Return True
If tnum >= 69 And tnum <= 74 Then Return True
If tnum = 62 Or tnum = 57 Then Return True

Return False
End Function

; //===================================================================================================
; // [Load Images Function]
; //===================================================================================================
Function LoadImages(Mode)
If Mode = 1 Then 
	tmp$ = "gfx/" 
ElseIf Mode = 2 Then
	tmp$ = "gfx2/"
ElseIf Mode = 3 Then
	tmp$ = "gfx3/"
EndIf

FreeImage img_b2: FreeImage img_Mario: FreeImage img_tiles: FreeImage img_b3: FreeImage img_digits
FreeImage img_logo: FreeImage img_coin: FreeImage img_qbox: FreeImage img_coin2
FreeImage img_Goomba: FreeImage img_Beatle: FreeImage img_Koopa: FreeImage img_Spikey
FreeImage img_face: FreeImage img_header

img_b2 = LoadImage(tmp$ + "b2.png", 1): MaskImage img_b2, 255, 0, 255
img_Mario = LoadAnimImage(tmp$ + "mario.png", 17, 32, 0, 7): MaskImage img_Mario, 255, 0, 255
img_tiles = LoadAnimImage(tmp$ + "tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
img_b3 = LoadImage(tmp$ + "b3.png", 1): MaskImage img_b3, 255, 0, 255
img_digits = LoadAnimImage(tmp$ + "digits.png", 8, 7, 0, 10)
img_logo = LoadImage(tmp$ + "logo.png", 1): MaskImage img_logo, 255, 0, 255
img_coin = LoadAnimImage(tmp$ + "coin.png", 10, 14, 0, 4): MaskImage img_coin, 255, 0, 255
img_qbox = LoadAnimImage(tmp$ + "qbox.png", 16, 16, 0, 4): MaskImage img_qbox, 255, 0, 255
img_coin2 = LoadAnimImage(tmp$ + "coin2.png", 8, 14, 0, 4): MaskImage img_coin2, 255, 0, 255
img_Goomba = LoadAnimImage(tmp$ + "goomba.png", 16, 16, 0, 9): MaskImage img_Goomba, 255, 0, 255
img_Beatle = LoadAnimImage(tmp$ + "beatle.png", 16, 16, 0, 18): MaskImage img_Beatle, 255, 0, 255
img_Koopa = LoadAnimImage(tmp$ + "koopa.png", 16, 24, 0, 12): MaskImage img_Koopa, 255, 0, 255
img_Spikey = LoadAnimImage(tmp$ + "spikey.png", 16, 16, 0, 4): MaskImage img_Spikey, 255, 0, 255
img_face = LoadImage(tmp$ + "face.png", 1)
img_header = LoadImage(tmp$ + "header.png", 1)

End Function

